﻿using Microsoft.AspNetCore.Identity;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations.Schema;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace MTWorkHR.Identity.Models
{
    public class ApplicationUser : IdentityUser
    {
        public string FirstName { get; set; }
        public string LastName { get; set; }
        public int UserType { get; set; }

        public string? ManagerId { get; set; }

        [ForeignKey("ManagerId")]
        public ApplicationUser Manager { get; set; }


        public string? CreateUser { get; set; }
        public string? UpdateUser { get; set; }

        public bool IsStopped { get; set; }
        public bool IsDeleted { get; set; }
        public string? DeleteUserId { get; set; }

        public ICollection<ApplicationRole> UserRoles { get; set; }

    }
}
